/*
 Copyright (C) 1997 by Alexander Pukhov, email: pukhov@theory.npi.msu.su 
*/
#define real double
#include "chep_crt.h"
#include "procvar.h"
#include "n_compil.h"
#include "out_int.h"
#include "out_ext.h"
#include "pvars.h"
#include "process.h"

double DP[15]; 

static double  calcpolynom(varptr  q)
{ double        s=0, m;
  short *  i; 

   if (q == NULL) return 0.0;
   do
   {
      m = q->coef->rval;
      i=q->vars;
      while(*i) {m*=vararr[*i].tmpvalue; i++;} 
      if (q->sgn == '+')  s += m;  else  s -= m;
      q = q->next;
   }  while (q);
   return s;
}



static void  calcconstants(void)
{infoptr  i_ptr;

   i_ptr = info;
   while (i_ptr)
   {
      if (i_ptr->consttype == expr) i_ptr->rval = calcpolynom(i_ptr->const_);
		else                i_ptr->rval = i_ptr->ival;
      i_ptr = i_ptr->next;
   }
}
 

static double  calconediagr(int cBasisPower, prgcodeptr  prg_,   
                             denlist denomi, int * err)
{  int     i;
   double  r, rr;

   rr = calcpolynom(prg_->totd);
   if (rr == 0)
   {  *err = 2;   /* Division by zero */
      return 0;
   }
  
   r = calcpolynom(prg_->rnum)*calcpolynom(prg_->totn)/rr;

   for (i = 0; i<prg_->denorno; i++)
   {  denlist den=denomi;
      while( prg_->order_num[i] !=den->order_num 
          || prg_->width[i]!=den->width ) den=den->next;    
      if (prg_->power[i] ==2) r*=den->val2;else r*=den->val1;
   }

   if(color_weights&&prg_->cCoefN)
   { 
      for(i=0; i<cBasisPower; i++)
      if(prg_->cCoefN[i]) color_weights[i] += (r*prg_->cCoefN[i])/prg_->cCoefD[i];
   }

   return r;
}

static double  matrixelement(int nsub, double * momenta, int *err)
{  double  sum=0.0; 
   prgcodeptr prg=allcanal[nsub-1].codeptr;
   denlist denomi=allcanal[nsub-1].denominators;
   denlist den=denomi;
   
   while (den)
   {  double rr, irr;

      rr =sqrMom(den->momStr,momenta);
      irr=vararr[den->mass].tmpvalue;
      rr =irr*irr - rr;
      
      irr=irr*vararr[den->width].tmpvalue;

      if (fabs(rr) + fabs(irr) == 0)
      {  *err = DENOMINATOR_ERROR;    /* Division by zero */
         return 0;
      }
      if(den->width)
      {  den->val2=1.0/(rr*rr+irr*irr);
         den->val1=rr*den->val2;
         den->val0=rr*den->val1;            
      }else
      {
         den->val0=1;
         den->val1=1/rr;
         den->val2=den->val1/rr;
      }
      den=den->next;
   }
   while (prg) 
   {  
      sum += calconediagr(allcanal[nsub-1].powerC,prg,denomi,err); 
      if (*err) return 0.0; 
      prg= prg->next; 
   } 
   return sum; 
} 

static void sprod_(double*);
static double smpl(int nsub,double* momenta,int * err)
{
  int i,j;
  double * mi,*mj;
 
  for(i=0;i<nin+nout-1;i++)
  {  mi=momenta+4*i;
     for(j=i+1;j<nin+nout;j++) 
     {  mj=momenta+4*j; 
        vararr[scalarProductPos(i+1,j+1)].tmpvalue=
        mi[0]*mj[0]-mi[1]*mj[1]-mi[2]*mj[2]-mi[3]*mj[3];
     }
  }
  if(calcCoef[1]) {calcconstants(); calcCoef[1]=0;}
 
  return  matrixelement(nsub, momenta, err);
}
#include"sqme0.c"
