#include<stdlib.h>
#include<stdio.h>

#include"events.h"
#include"vegas.h"
#include"drandXX.h"
#include"chep_crt.h"
#include"out_ext.h"
#include"4_vector.h"
#include<unistd.h>

static FILE * events_;
static long eventsBeg=0;
static long eventsLen=0;

static FILE * events_cub=NULL;
static int EOF_events;



static void initBackFire(void)
{  events_cub=fopen("BackFire.tmp","wb+"); 
   eventsBeg=ftell(events_);
   eventsLen=0;
   EOF_events=1;
}

static void closeBackFire(void)
{  fclose(events_cub);
   unlink("BackFire.tmp");
   events_cub=NULL;
   fseek(events_,0,SEEK_END);
}
      

static void writeEvent(long cCub,  int n, char * rand_state)
{ 
   int i;
   
   fprintf(events_,"%04X|%05X|",n,cCub); 
   if(n==0) return;
   fprintf(events_,"%s",rand_state);
/*   
   if(nin_==2)

   fprintf(events_," %17.10E %17.10E",pvect[3],pvect[7]);

   for(i=0;i<nout_;i++) fprintf(events_," %17.10E %17.10E %17.10E",
   pvect[4*(i+nin_)+1],pvect[4*(i+nin_)+2],pvect[4*(i+nin_)+3]);
*/
   fprintf(events_,"\n");
   
   if(events_cub) 
   { if(eventsLen==0)eventsLen=ftell(events_)-eventsBeg;
     fwrite(&cCub,sizeof(cCub),1,events_cub);
     if(!EOF_events) 
     { long xCub=1;
       long fpos=ftell(events_cub);
       fseek(events_cub, fpos,SEEK_SET);
       while((!EOF_events)&&xCub>=0) 
                     EOF_events=!fread(&xCub,sizeof(xCub),1,events_cub);
       fpos=ftell(events_cub);
       if(xCub<0) fpos -= sizeof(long);
       fseek(events_cub,fpos,SEEK_SET);
       fpos= eventsBeg + eventsLen* (fpos/sizeof(long));  
       fseek(events_, fpos, SEEK_SET);
    }
  }        
}


static void kill_events(long cub, double killProb,long * nKilled)
{ long cub_,fpos;

  *nKilled=0;  
  fseek(events_cub,0,SEEK_SET);
  while(fread(&cub_,sizeof(long),1,events_cub))

  if(cub_==cub && killProb <  drandXX())
  {  fpos=ftell(events_cub)-sizeof(long);  
     fseek(events_cub,fpos,SEEK_SET);
     cub_=-1;
     fwrite(&cub_,sizeof(cub_),1,events_cub);     
     fseek(events_cub,fpos+sizeof(long),SEEK_SET);
     fpos=eventsBeg+eventsLen*(fpos/sizeof(long));
     fseek(events_,fpos,SEEK_SET);
     writeEvent(0,0,NULL);
     (*nKilled)++;
  }

  fseek(events_cub,0,SEEK_SET);
  
  EOF_events=0;
  cub_=1;
  while((!EOF_events)&&cub_!=-1) 
                     EOF_events=!fread(&cub_,sizeof(cub_),1,events_cub);
  fpos=ftell(events_cub);
  if(cub_==-1)fpos-=sizeof(long);
  fseek(events_cub,fpos,SEEK_SET);
  fpos= eventsBeg + eventsLen* (fpos/sizeof(long));  
  fseek(events_, fpos, SEEK_SET);
}


void  generateEvents( vegasGrid * vegPtr, double (*func)(double *,double),
                   FILE * events, long * nGenerated)
{                                                   
   float * fmax;
   long nEvents=10000;
   long n_cube=1000; 
   long nPoints=100;
   int mode=1;
   double milk=0;
   void *pscr=NULL;
   double max=2;
   long fileposEv;
   long fileposEnd;
   int backFire=0;
   int i,j;
   
   *nGenerated=0;   
   events_=events;   
   fileposEv=ftell(events);
   fprintf(events," Number of events: %10d\n",*nGenerated);
   for(mode=1;mode!=5; )
   {
      char strmen[]="\030"
                    " sub-cubes = N1         "
                    " calls     = N2         "
                    " simplex search    |ONN "
                    " milk      = N3         "  
                    " Search of maximums     "; 
      improveStr(strmen,"N1","%d",n_cube);
      improveStr(strmen,"N2","%d",nPoints);
      improveStr(strmen,"N3","%.1f",milk);
      if(simplexOn) improveStr(strmen,"|ONN","|ON ");
          else      improveStr(strmen,"|ONN","|OFF");
      
   
      menu1(54,11,"Preparing of generator",strmen,"n_veg_*",&pscr,&mode);
      switch(mode)
      {
        case 0: return;
        case 1: correctLong(50,15,"Number of sub-cubes:",&n_cube,1); break;
        case 2: correctLong(50,15,"Calls for each sub-cube:",&nPoints,1);break;
        case 3: simplexOn=!simplexOn; break; 
        case 4: correctDouble(50,15,"Content of milk:",&milk,1); break;
        case 5: fmax=malloc(n_cube*sizeof(float));
          { float * fmax_=malloc(n_cube*sizeof(float));                                  
            float * sum  =malloc(n_cube*sizeof(float));                                  
            if(fmax&&fmax_&&sum)                                                         
            {  free(sum); free(fmax_);                                                   
               vegas_max(vegPtr, n_cube, nPoints, func, milk,  fmax);
               put_text(&pscr); 
            } else                                                                       
            {  if(sum) free(sum); if(fmax_) free(fmax_); if(fmax) free(fmax);                         
               messanykey(25,15,"Not enouth memory.\n"                                    
                                "Decrease the number of sub-cubes");                     
                mode=1;                                                                  
            }                                                                            
          }                                                                              
      }
   }
   
   fprintf(events,"  Events:"); 
   if(nin_==2) fprintf(events,"     P1_3 [Gev]        P2_3 [Gev]   ");
   for(i=1;i<=nout_; i++) for(j=1;j<=3;j++) 
                          fprintf(events,"     P%d_%d [Gev]   ",i+nin_,j);
   fprintf(events,"\n");
   fileposEnd=ftell(events); 
    
   for(mode=1;;)
   {
     char strmen[]="\030"
                   "Number of events=N1     "
                   " MAX*N2                 "
                   " Backfire        OFF    " 
                   " Launch generator       ";
     improveStr(strmen,"N1","%d",nEvents);
     improveStr(strmen,"N2","%.2G",max);
     if(backFire) improveStr(strmen,"OFF","ON ");
     menu1(54,10,"",strmen,"n_veg_*",&pscr,&mode);
     switch(mode)
     { case 0: if(mess_y_n(25,15,"Finish generation?")) 
               return;
               break; 
               case 1: correctLong(50,15,"",&nEvents,1); break;
       case 2:correctDouble(50,15,"Increase max in ",&max,1); break;
       case 3: backFire=!backFire; break;
       case 4: 
       { double eff,rmax,mult,neg;
         char mess[200];
         int broken;
         
         if(backFire) initBackFire();
         broken=
         vegas_events(vegPtr,n_cube,nEvents,max,  func, writeEvent,
         backFire? kill_events :NULL,  fmax, &eff,&rmax,&mult,&neg);
         if(backFire) closeBackFire(); 
         sprintf(mess,"Statistic\n efficiency: %.1E\nReached max: %.1E\n"
                      "Mult. events: %.1E \nNeg.events: %.1E \n",
                      eff,rmax,mult, neg);
         if(broken)  
         { strcat(mess,"---------------\n Events are not saved"); 
           messanykey(25,15,mess);
           fseek(events,fileposEnd,SEEK_SET);
         }
         else   
         { strcat(mess,"---------------\n Accept events? ");    
           if(mess_y_n(25,15,mess)) 
           { *nGenerated+=nEvents;
             fileposEnd=ftell(events);
             fseek(events,fileposEv ,SEEK_SET);
             fprintf(events," Number_of_events: %10d",*nGenerated);
             fseek(events,fileposEnd,SEEK_SET);
             fflush(events);
           } else fseek(events,fileposEnd,SEEK_SET);
         } 
       }
     }
   }
}                                                                     
