#include<stdlib.h>
#include<stdio.h>
#include"vegas.h"
#include"drandXX.h"
#include"chep_crt.h"
#include"out_ext.h"
#include"4_vector.h"
#include"subproc.h"
#include"alphas2.h"
#include<unistd.h>
#include"strfun.h"
#include"files.h"
#include"runVegas.h"
#include"events.h"


static FILE * events_;
static int nC, cBasisPower, *cChains;

static void writeEvent(long cCub,  int n, char * rand_state)
{ 
   int i;
   int icc;
#ifdef PARKED 
 fprintf(events_,"%05X|%s|%d\n",cCub,rand_state,n);
#else

   if(cBasisPower)
   {  double sum=0;
      for(i=0;i<cBasisPower;i++) sum+=fabs(color_weights[i]);
      sum*=drandXX();
      for(i=0;i<cBasisPower;i++)
      { sum-=fabs(color_weights[i]);
        if(sum<=0) break;
      } 
      if(i==cBasisPower) i--;
      if(color_weights[i]<0) n*=-1;
      icc=i;
   }
   

   fprintf(events_,"%8d ",n);  
   if(nin_==2)

   fprintf(events_," %17.10E %17.10E",pvect[3],pvect[7]);

   for(i=0;i<nout_;i++) fprintf(events_," %17.10E %17.10E %17.10E",
   pvect[4*(i+nin_)+1],pvect[4*(i+nin_)+2],pvect[4*(i+nin_)+3]);

   fprintf(events_," %10.3E ", scale_());

   
   if(cBasisPower)
   {  int j;
      fprintf(events_,"  ");
      for(j=0;j<nC;j++)
      fprintf(events_,"(%d %d)",cChains[2*nC*icc+2*j], cChains[2*nC*icc+2*j+1]);
   }


   fprintf(events_,"\n");

#endif   
}


static float * fmax=NULL;
static int killMaxInfo=1;
static long n_cube=1000;
   
int saveEventMax(FILE * f)
{  long l;
    
   fprintf(f,"nCub=%d \n",n_cube);
   if(fmax) 
   {  fprintf(f,"Max:\n");
      for(l=0;l<n_cube;l++) fprintf(f,"%.1E\n",fmax[l]);
   } else fprintf(f,"!Max\n");

   return 0;
}

int  readEventMax(FILE * f)
{  long l;
   char buff[10];

   fscanf(f,"nCub=%ld\n",&n_cube);
   fscanf(f,"%s",buff);  
   if(strcmp(buff,"Max:")==0)
   {  fmax=malloc(n_cube*sizeof(float));
      for(l=0;l<n_cube;l++)fscanf(f,"%f",fmax+l); 
      killMaxInfo=0; 
   }else { if(fmax) free(fmax); fmax=NULL;}
   return 0;
}


static long nPoints=100;
static long nEvents=10000;
static  double max =2;
static double milk=0.2; 

int saveEventSettings(FILE * f)
{
  fprintf(f, "%d %d %f %f %d", nPoints, simplexOn, milk, max, nEvents);
  return 0;

}

int  readEventSettings(FILE * f)
{
  fscanf(f, "%ld %d %lf %lf %ld", &nPoints, &simplexOn, &milk, &max, &nEvents);
  return 0;
}


static void write_event_cap(void) 
{
  int i,j;
  fprintf(events_,"#%s\n",version);

  fprintf(events_,"#PROCESS  ");
  for(i=1;i<=nin_+nout_; i++)
  { char buff[10];
    pinf_(proces_1.nsub,i,buff,NULL);
    fprintf(events_," %-4.4s", buff);
    if(i==nin_)  fprintf(events_,"->");
  } 
  fprintf(events_,"\n");  
  
  fprintf(events_,"#Initial_state\n");

 /* w_in__(events_); */
  {  double sqrt_S;
     vinf_(0,NULL,&sqrt_S);
     fprintf(events_,"  SQRT(S) %E\n  Rapidity(c.m.s) %E\n",sqrt_S,rapidity);
     wrt_sf__(events_);
  }
  
  
  fprintf(events_,"#MASSES ");
  for(i=1;i<=nin_+nout_; i++)
  { double q;
    pinf_(proces_1.nsub,i,NULL,&q);
    fprintf(events_," %.10E", q);
  } 
  fprintf(events_,"\n");
  
  if(integral.n_it) fprintf(events_,"#Cross_section(Width) %E\n",
                                                     integral.s1/integral.s0);
  else   fprintf(events_,"#Cross_section(Width) Unknown\n"); 
  fprintf(events_,"#Number_of_events %10d\n",0);

  fprintf(events_,"#Events  "); 
  if(nin_==2) fprintf(events_,"     P1_3 [Gev]        P2_3 [Gev]   ");
  for(i=1;i<=nout_; i++) for(j=1;j<=3;j++) 
                          fprintf(events_,"     P%d_%d [Gev]   ",i+nin_,j);

  fprintf(events_,"  QCD SCALE    Color chains\n");

}



   
void  generateEvents( vegasGrid * vegPtr, int init, 
                   double (*func)(double *,double),  char *fname,  FILE * iprt)
{                                                   
   int mode=1;
   void * pscr=NULL;
   void * pscr_=NULL;
   double max=2;
   double eff0;
   
   if(init){ if(fmax) free(fmax); fmax=NULL;}
   
ret:  
   if(!fmax)for(mode=1;mode!=4; )
   {   
      char strmen[]="\030"
                    " sub-cubes = N1         "
                    " calls     = N2         "
                    " simplex search    |ONN "
                    " Start search of maxima "; 
      improveStr(strmen,"N1","%d",n_cube);
      improveStr(strmen,"N2","%d",nPoints);
      if(simplexOn) improveStr(strmen,"|ONN","|ON ");
          else      improveStr(strmen,"|ONN","|OFF");
      menu1(54,11,"Preparing of generator",strmen,"n_prep_gen_*",&pscr_,&mode);
      switch(mode)
      {
        case 0: return;
        case 1: correctLong(50,15,"Number of sub-cubes:",&n_cube,1); 
	        generateVegasCubs(vegPtr,&n_cube);
		break;
        case 2: correctLong(50,15,"Calls for each sub-cube:",&nPoints,1);break;
        case 3: simplexOn=!simplexOn; break; 

/*                    " milk      = N3         "  
      improveStr(strmen,"N3","%.1f",milk);
        case 4: correctDouble(50,15,"Content of milk:",&milk,1); break;
*/
        case 4: if(n_cube < 1 ) n_cube=1; 
	   fmax=malloc(n_cube*sizeof(float));
          { float * fmax_=malloc(n_cube*sizeof(float));                                  
            float * sum  =malloc(n_cube*sizeof(float));                                  
            if(fmax&&fmax_&&sum)                                                         
            {  free(sum); free(fmax_);                                                   
               if(vegas_max(vegPtr, n_cube, nPoints, func, milk,&eff0, fmax)==0)
               { char mess[50];
                 sprintf(mess,"Expected efficiency %f",eff0);
                 messanykey(25,15,mess);
                 put_text(&pscr_);
               } else mode=1;
            } else                                                                       
            {  if(sum) free(sum); if(fmax_) free(fmax_); if(fmax) free(fmax); 
	       fmax=NULL;                        
               messanykey(25,15,"Not enough memory.\n"                                    
                                "Decrease the number of sub-cubes");                     
                mode=1;                                                                  
            }                                                                            
          }                                                                             
       }
   }
   killMaxInfo=0; 
    
   for(mode=1;;)
   {
     char strmen[]="\030"
                   "Number of events=N1     "
                   " MAX*N2                 "
                   " Launch generator       "
		   " New search of maxima   ";
     improveStr(strmen,"N1","%d",nEvents);
     improveStr(strmen,"N2","%.2G",max);
     menu1(54,10,"",strmen,"n_gen_*",&pscr,&mode);
     switch(mode)
     { case 0: return; 
       case 1: correctLong(50,15,"",&nEvents,1); break;
       case 2: correctDouble(50,15,"Increase max in ",&max,1); break;
       case 3: 
       { long  nGenerated=0; 
         double eff, rmax, mult, neg;   
         char mess[200];
         int broken;
         long fileEnd;

         events_=fopen(fname,"a");       
         if(ftell(events_)==0) write_event_cap();

         fileEnd=ftell(events_); 

         cStrings(proces_1.nsub ,&nC,&cBasisPower,&cChains);  
         if(cBasisPower)color_weights=malloc(sizeof(double)*cBasisPower);
         
         broken= vegas_events(vegPtr,n_cube,nEvents,max,  func, writeEvent,
         fmax, &eff,&rmax,&mult,&neg);
         fclose(events_);

         sprintf(mess,"Statistic\n efficiency: %.1E\nReached max: %.1E\n"
                      "Mult. events: %.1E \nNeg.events: %.1E \n",
                      eff,rmax,mult, neg);

         if(broken)  
         {  strcat(mess,"---------------\n Events are not saved"); 
            messanykey(25,15,mess);
            truncate(fname,fileEnd);
         }
         else   
         {  int l=strlen(mess);
            strcat(mess,"---------------\n Accept events? ");    
            if(mess_y_n(25,15,mess)) 
            {  
               long  nEvPos=0;
               integral.old=1;
               mess[l]=0;
               events_=fopen(fname,"r+");
               while(nEvPos==0)
               { char ch;
                 char word[100];
                 do fscanf(events_,"%c",&ch); while(ch !='#');
                 fscanf(events_,"%s",word);
                 if(strcmp(word,"Number_of_events")==0) nEvPos=ftell(events_);
               }
               fscanf(events_,"%ld",&nGenerated);
               nGenerated+=nEvents;
               fseek(events_,nEvPos,SEEK_SET);
               fprintf(events_," %10d",nGenerated);
               fclose(events_);

               fprintf(iprt," %d events are stored in '%s'\n",nEvents,fname);
               fprintf(iprt,"%s\n",mess);
               fflush(iprt);
            } else  truncate(fname,fileEnd);
         }
         if(cBasisPower) { free(color_weights); color_weights=NULL;}
       } 
       break;
       case 4: free(fmax); fmax=NULL;
       put_text(&pscr);
       goto ret;
     }
   }
}                                                                     
