/*
 Copyright (C) 1997, Slava Ilyin
*/
#include"out_ext.h"
#include"tptcmac.h"

#include"cut.h"
#include"kinaux.h"
#include"kininpt.h"

#include"regul.h"
#include"rw_sess.h"
#include"alphas2.h"
#include"out_ext.h"
#include"histogram.h"
#include"crt_util.h"
#include"n_comphep_.h"
#include"runVegas.h"
#include"drandXX.h"
#include"out_ext.h"

#include"strfun.h"
#include"files.h"
#include"subproc.h"
#include"paragraphs.h"
#include"events.h"


static int writeIntegral(FILE *f)
{
  fprintf(f," %.17E %.17E %.17E %d %d %d", integral.s0,integral.s1,integral.s2,
  integral.n_it, integral.old, integral.nCallTot);
  return 0;
}

static int readIntegral(FILE *f)
{
  fscanf(f," %lf %lf %lf %d %d %ld", &(integral.s0),&(integral.s1),
  &(integral.s2),&(integral.n_it),&(integral.old), &(integral.nCallTot));
  return 0;
}



/*  read-write the number of session *** */
static int wnsess_(FILE *mode)
{
   fprintf(mode,"%d",nSess);
   return 0;
}

static int insess_(void) { nSess = 1; return 0;}

static int rnsess_(FILE *mode)
{
  fscanf(mode,"%d",&nSess); return 0;
}

/* ******************************************** */
/*   write process string */
/* ******************************************** */
int wrtprc_(void)
{
    char buff[10];
  
    int pos=0;
    int i;
    for (i=1;i<=nin_+nout_ ;i++)
    { 
       pinf_(proces_1.nsub,i,buff,NULL);
       strcpy(proces_1.proces+pos,buff);
       pos+=strlen(buff);
       
       if (i<nin_+nout_)
       { 
          if( i==nin_) {strcpy(proces_1.proces+pos," -> "); pos+=4;}
           else          {strcpy(proces_1.proces+pos,", ");pos+=2;}
       }
    }   
    return 0;
}

static int i_prc__(void)
{  proces_1.nsub=1;
   wrtprc_();
   return 0;
}

static int w_prc__(FILE *mode)
{ return  fprintf(mode,"%d (%s)",proces_1.nsub,proces_1.proces); }

static int r_prc__(FILE *mode)
{  char proc_name[100];

   fscanf(mode,"%d (%[^)]",&proces_1.nsub,proc_name);
   if(proces_1.nsub> nprc_) return 2;
   wrtprc_();
   if (strcmp(proc_name,proces_1.proces)==0) return 0; else return 2;
}


/* *  read-write MC parameters       *** */
static int w_mc__(FILE *mode)
{
  fprintf(mode,"%dx%d",mcintr_1.ncall0,mcintr_1.itmx0);
  return 0;
}


static int r_mc__(FILE *mode)
{
  fscanf(mode,"%ldx%d",&mcintr_1.ncall0,&mcintr_1.itmx0);
  return 0;
}


static int w_mdl__(FILE * mode)
{
  long i;
  double val;
  char name[10];

  fprintf(mode,"\n"); 
  for (i = 1; i <= nvar_; ++i) 
  {
     vinf_(i, name, &val);
     fprintf(mode,"%10s = %.15E\n",name,val);
  }
  return 0;
}


static int r_mdl__(FILE * mode)
{
    static double val;
    long i;
    char name1[20],name2[20];
    
    for (i = 1; i <= nvar_; ++i) 
    { if(2!= fscanf(mode,"%s = %lf",name1,&val)) return 2;
      vinf_(i,name2,NULL);
      if(strcmp(name1,name2)) return 2;
      asgn_(i, val);
    }
    return 0;
} 

/* *  read-write IN-state parameters  *** */
static int w_in__(FILE *mode)
{  double sqrt_S;
   vinf_(0,NULL,&sqrt_S);
   fprintf(mode,"  SQRT(S) %E\n  Rapidity(c.m.s) %E\n",sqrt_S,rapidity);
   wrt_sf__(mode);
   return 0;
}


static int r_in__(FILE *mode)
{ double sqrt_S;
  
  fscanf(mode,"  SQRT(S) %lf\n  Rapidity(c.m.s) %lf\n",&sqrt_S,&rapidity);
  asgn_(0,sqrt_S);
  rd_sf__(mode);
  
  return 0;
}


static int saveRandom(FILE *f)
{
   fprintf(f,"%s\n",seedXX(NULL));
   return 0;
}

static int readRandom(FILE *f)
{
  char s[20];
  fscanf(f,"%s",s);
  seedXX(s);
  
  return 0;
}

int w_sess__(FILE *mode_)
{
   FILE*mode;
   rw_paragraph  wrt_array[15]=
   {
      {"Subprocess",  w_prc__},
      {"Session_number",  wnsess_},
      {"Initial_state",  w_in__},
      {"Physical_Parameters",  w_mdl__},
      {"Kinematical_scheme",  wrtkin_},
      {"Cuts",  wrtcut_},
      {"Regularization",  wrtreg_},
      {"QCD",  w_qcd__},
      {"Vegas_calls",  w_mc__},
      {"Vegas_integral", writeIntegral},
      {"Distributions", wrt_hist},
      {"Events",saveEventSettings},
      {"Random", saveRandom},
      {"VEGAS_Grid", saveVegasGrid},
      {"MAX",saveEventMax}
   };

   if(nin_==1) wrt_array[2].rw_command=NULL;

   if (mode_ == NULL)
   { char fname[100];
     sprintf( fname,"%ssession.dat",outputDir);
       mode=fopen(fname,"w");
      if(mode == NULL) return 0;
   } else mode=mode_;

   if(mode_ == NULL)
   {
      writeParagraphs(mode,15,wrt_array);
      fclose(mode);
   } else   writeParagraphs(mode,8,wrt_array);

   return 0;
}    

int r_sess__(FILE *mode_)
{
  FILE*mode;
  
 rw_paragraph  rd_array[15]=
 {
   {"Subprocess",  r_prc__},
   {"Session_number",  rnsess_},
   {"Initial_state",  r_in__},
   {"Physical_Parameters",  r_mdl__},
   {"Kinematical_scheme",  rdrkin_},
   {"Cuts",  rdrcut_},
   {"Regularization",  rdrreg_},
   {"QCD",  r_qcd__},
   {"Distributions", rdr_hist},
   {"Vegas_integral", readIntegral},
   {"Vegas_calls",  r_mc__},  
   {"Events", readEventSettings},
   {"Random", readRandom},
   {"VEGAS_Grid",readVegasGrid},
   {"MAX", readEventMax}
 };
                       
                         
 if(interpret) return 0;

 if (mode_ == NULL) 
 { 
   mode=fopen("session.dat","r"); 
   if (mode ==NULL) return 0;
 }else mode=mode_;
 readParagraphs(mode, 15,rd_array); 
 
 if (mode_ == NULL) fclose(mode); 

 return 0;
} /* r_sess__ */


void  inipar_(void)
{
 i_prc__(); /*                     from comphep output */
 insess_();
 stdkin_();

 i_qcd();
 rapidity=0;
 rwidth=0;
 gwidth=0; 
} /* inipar_ */

void clearSession(void)
{
   cleartab(&cutTab);
   cleartab(&regTab);
   cleartab(&histTab); clearHists();
}
