/* 
  Copyright (C) 1999, Slava Bunichev 
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "spline2.h"

/* +++++++++++++++++ progonca ++++++++++++++++++++++++ */
void progonca(int N,double* f,double* d)
{ int j;
  double *alfa,*beta;

  alfa=(double *)malloc((N+1) *sizeof(double));
  beta=(double *)malloc((N+1) *sizeof(double));

/*------------- nachalnie uslovia dla progonki --------------------*/
  alfa[3]= -1./5.;
  beta[3]= -6./5.*(f[0]-3*f[1]+3*f[2]-f[3]);
/*-------- vichislenie coefficientov dla progonki -----------------*/
  for(j=3;j<=N-2;j++)
   { alfa[j+1]= 1./(-4.-alfa[j]);
     beta[j+1]= ( beta[j]+6.*(f[j-2]-3.*f[j-1]+3.*f[j]-f[j+1]) )*alfa[j+1];
   }

/*---- vichislenie coefficientov  d[i] dla spline ------------------*/
  d[N-1]= ( -1./5.*beta[N-1] -6./5.*(f[N-3]-3.*f[N-2]+3.*f[N-1]-f[N]) )
	   /(1.+1./5.*alfa[N-1]);
  for(j=N-2;j>=2;j--)
    d[j]= alfa[j+1]*d[j+1]+beta[j+1];

  d[1]=d[2];
  d[N]=d[N-1];
/*-----------------------------------*/
  free((void*)alfa);
  free((void*)beta);

}



/* ++++++++++++++++++++ b_and_d ++++++++++++++++++++++++++++++++++++++++ */
void b_and_c(int N,double* f,double* b,double* c,double* d)
{ int i;

  for(i=N;i>=2;i--)
    c[i]= 5./6.*d[i] +1./6.*d[i-1] +(f[i]-2*f[i-1]+f[i-2]);

  c[1]=c[2]-d[2];

  for(i=1;i<=N;i++)
    b[i]= 1./2.*c[i]-1./6.*d[i]+(f[i]-f[i-1]);

printf("b_and_c\n");
}



/* ++++++++++++++++++++++ spline_for_graph ++++++++++++++++++++++++++++++++++++++++++ */
double spline_for_graph(double iks,double* f,double* b,double* c,
			double* d)
{ int i;
  double delta_x;

  if(iks==i) i=iks;
  else       i=iks+1;

  delta_x=iks-i;
  return( f[i] +b[i]*delta_x +c[i]/2.*delta_x*delta_x
	  +d[i]/6.*delta_x*delta_x*delta_x );
}
/* ++++++++++++++++++++++ curve +++++++++++++++++++++++++++++++++++++++++ 
static void curve(double* S,int N,double* I,double* b,double* c,double* d)
{ int j;
  double iks;
      for(j=0;j<=400;j++)
       { iks =j/400.0*N;
	 S[j]= spline_for_graph(iks,I,b,c,d);
       }

}

*/

/* +++++++++++++++++++++++++++ INTEGRALS +++++++++++++++++++++++++++++++ */
static void INTEGRALS_2(int koeff,int n,double *Iexp,double *dIexp,double *I,
		 double **A,double **F3,double *b,double *c,double *d)
{ int i,j,N,s;
  double *f;

  N= koeff*(n+1);

  f=(double *)malloc((N+1) *sizeof(double));


  for(j=0;j<=N;j++)
       f[j]=0;

  for(i=0;i<=N;i++)
   for(j=0;j<=N;j++)
      { A[i][j]=0;
	F3[i][j]=0;
      }
/*------------- Iexp[i]/dIexp[i] -------------------*/
 for(i=0;i<=n;i++)
 { if(dIexp[i]==0)  dIexp[i]=1.e-20;
   I[i]=Iexp[i]/dIexp[i];
 }
/*--------------------------------------------------*/

for(i=0;i<=N;i++)
{
  if(i==0)
   { f[0]=1;
     f[1]=1./8.;
    }
  if(i==1)
   { f[0]=0;
     f[1]=1;
     f[2]=8./37.;
    }
  if(i==2)
   { f[2]=1;
     f[1]=1./8.;
     f[3]=1./4.;
    }
  if(i==3)
   { f[3]=1;
     f[2]=9./37.;
     f[4]=1./4.;
    }

  if( (i>=4)&&(i<=(N-4)) )
   { f[i]=1;
     f[i-1]=1./4.;
     f[i+1]=1./4.;
    }

  if(i==(N-3))
   { f[N-3]=1;
     f[N-2]=9./37.;
     f[N-4]=1./4.;
    }
  if(i==(N-2))
   { f[N-2]=1;
     f[N-1]=1./8.;
     f[N-3]=1./4.;
    }
  if(i==(N-1))
   { f[N-1]=1;
     f[N-2]=8./37.;
    }
  if(i==N)
   { f[N]=1;
     f[N-1]=1./8.;
    }


      progonca(N,f,d);
      b_and_c(N,f,b,c,d);


/*-----------------integrals ------------------------------------*/

 for(j=0;j<=n;j++)
   { for(s=1;s<=koeff;s++)
     { A[i][j]= A[i][j]+( f[j*koeff+s]-b[j*koeff+s]/2.+c[j*koeff+s]/6.
			 -d[j*koeff+s]/24.)/(dIexp[j]*koeff);

       if(Iexp[j]==0) Iexp[j]=1.e-20;
       if((j*koeff+s)==N) F3[i][j*koeff+s]= 0;
       else               F3[i][j*koeff+s]=(d[j*koeff+s]-d[j*koeff+s+1])/fabs(Iexp[j]*Iexp[j]*Iexp[j]);

     }
   }

 if(i!=0)  f[i-1]=0;

}

 free((void*)f);

}


/*+++++++++++++++++++++ B_and_C_for_GAUSS ++++++++++++++++*/
static void B_and_C_for_GAUSS(int koeff,double psi,int N,double **A,double **F3,
			   double *I,double *B, double **C)
{ int g,v,i,j,l,s;

  for(i=0;i<=N;i++)
   { B[i]=0;
     for(j=0;j<=N;j++) C[i][j]=0;
   }
/*------------------C[i][j] and B[j] -----------------*/
 for(g=0;g<=N;g++)
  { if(g>=5)  s=g-5;
    else      s=0;

    if(g<=(N-5)) l=g+5;
    else         l=N;

    for(v=s;v<=l;v++)
/*   for(v=0;v<=N;v++)*/
     { C[g][v]=0;
       for(j=0;j<=N/koeff-1;j++)
	{for(s=1;s<=koeff;s++)
	  C[g][v]=C[g][v]+psi*F3[g][j*koeff+s]*F3[v][j*koeff+s];
	 C[g][v]=C[g][v]+A[g][j]*A[v][j];
	}
      }

   }

 for(g=0;g<=N;g++)
  { B[g]=0;
   for(j=0;j<=N/koeff-1;j++)
      B[g]=B[g]+A[g][j]*I[j];
   }

}



/* +++++++++++++++++++++ GAUSS +++++++++++++++++++++++ */
static void GAUSS(int N,double *B,double **C)
{ int i,j,k,s;

for(k=5;k>=1;k--)
 for(j=k;j<=N;j++)
  if(C[j-1][j-k]!=0)
  { B[j]=B[j]-B[j-1]*C[j][j-k]/C[j-1][j-k];
    if((N-j)>=5) s=j+5;
    else           s=N;
    for(i=s;i>=j-k;i--)
      C[j][i]=C[j][i]-C[j-1][i]*C[j][j-k]/C[j-1][j-k];
  }

B[N]=B[N]/C[N][N];

for(j=N-1;j>=0;j--)
 { if((N-j)>=5) s=j+5;
   else           s=N;
   for(i=s;i>=j+1;i--)
     B[j]=B[j]-C[j][i]*B[i];
   B[j]=B[j]/C[j][j];
 }


}

/* +++++++++++++++++++++ KSI_2 ++++++++++++++++++++++++++++++++++++++++*/
static double KSI_2(double psi,int koeff,int n,double *Iexp,double *dIexp,double *I,double **A,
	     double **F3,double *B,double **C)
{ int i,j,N;
  double ksi2,*Iteor;

  N=koeff*(n+1);
  Iteor=(double *)malloc((n+1) *sizeof(double));

/*------------ INTEGRALS end GAUSS -------------------*/
 B_and_C_for_GAUSS(koeff,psi,N,A,F3,I,B,C);
 GAUSS(N,B,C);


 for(i=0;i<=n;i++)  Iteor[i]=0;
 ksi2=0;
/*---------------- ksi2----------------------------------------------*/
for(i=0;i<=n;i++)
  for(j=0;j<=N;j++)
    Iteor[i]=Iteor[i]+B[j]*A[j][i]*dIexp[i];

for(i=0;i<=n;i++)
 ksi2=ksi2+(Iteor[i]-Iexp[i])*(Iteor[i]-Iexp[i])/(dIexp[i]*dIexp[i]);
/*--------------------------------------------------------------------*/

 free((void*)Iteor);
 return(ksi2);

}

/* ++++++++++++++++++++ dikhotomia +++++++++++++++++++++++++*/
static void dikotomia(double *finale_psi,int koeff,int n,double *Iexp,double *dIexp,double *I,double **A,
	     double **F3,double *B,double **C)
{ double  psi,
	  psi_left,psi_right,
	  ksi_left,ksi_right,
	  delta,delta_ksi,ksi_psi,old_psi;

    psi=1.0e-5;
    delta_ksi=n*0.1;
  /*------------ psi_left AND psi_right ---------------*/
   psi_right=psi;
   psi_left=psi;

   ksi_right=KSI_2(psi_right,koeff,n,Iexp,dIexp,I,A,F3,B,C);
   ksi_left=ksi_right;
  /*-------------------------*/
   delta=ksi_right-(n+1);
   if(delta<0) delta=-delta;
  /*-------------------------*/

   if(delta>delta_ksi)
   {
    if( ksi_right<(n+1) )
     while( ksi_right<(n+1) )
	{ psi_left=psi_right;
	  psi_right=psi_right*2.;

	  ksi_left=ksi_right;
	  ksi_right=KSI_2(psi_right,koeff,n,Iexp,dIexp,I,A,F3,B,C);
	}
    else
     while( ksi_left>(n+1) )
	{ psi_right=psi_left;
	  psi_left=psi_left/2.;
	  if(psi_left<0) psi_left=0;

	  ksi_right=ksi_left;
	  ksi_left=KSI_2(psi_left,koeff,n,Iexp,dIexp,I,A,F3,B,C);
	}
    }


   printf("psi_left= %e\n",psi_left);
   printf("psi_right= %e\n\n",psi_right);


  /*--------------- dikhotomia ------------------------*/

   psi=(psi_left+psi_right)/2.0;
   ksi_psi=KSI_2(psi,koeff,n,Iexp,dIexp,I,A,F3,B,C);

   
   delta=ksi_psi-(n+1);
   if(delta<0) delta=-delta;


   while(delta>delta_ksi)
   { 
     psi=(psi_left+psi_right)/2.0;
     printf("psi= %.e\n",psi);
     ksi_psi=KSI_2(psi,koeff,n,Iexp,dIexp,I,A,F3,B,C);
     /*-------------------------*/
     delta=ksi_psi-(n+1);
     if(delta<0)
       { delta=-delta;
	 psi_left=psi;
	}

     else  psi_right=psi;
     
    }
/*----------------------------------------------------*/
*finale_psi=psi;

}


/* +++++++++++++++++++++++ SPLINE ++++++++++++++++++++++++++++++++++++++ */
void SPLINE2(int koeff,int n,double *Iexp,double *dIexp,double *I)
{
 int i,j,N;
 double psi,ksi2;

 double **A,**F3,*B,**C;
 double *b,*c,*d;
 
 n--;

 N= (n+1)*koeff;

 A=(double **)malloc((N+1) *sizeof(double *));
 for(j=0;j<=N;j++)
  A[j]=(double *)malloc((N+1) *sizeof(double));


 F3=(double **)malloc((N+1) *sizeof(double *));
 for(j=0;j<=N;j++)
  F3[j]=(double *)malloc((N+1) *sizeof(double));

 B=(double *)malloc((N+1) *sizeof(double));

 C=(double **)malloc((N+1) *sizeof(double *));
 for(j=0;j<=N;j++)
  C[j]=(double *)malloc((N+1) *sizeof(double));



 /* I=(double *)malloc((N+1) *sizeof(double));*/
  c=(double *)malloc((N+1) *sizeof(double));
  b=(double *)malloc((N+1) *sizeof(double));
  d=(double *)malloc((N+1) *sizeof(double));





 /*------------------A[i][j],C[i][j] and B[j] -----------------*/

  for(i=0;i<=N;i++)
   { B[i]=0;
     for(j=0;j<=N;j++) C[i][j]=0;
   }
/*---------------------------------------------*/

 INTEGRALS_2(koeff,n,Iexp,dIexp,I,A,F3,b,c,d);

/*------------ psi and ksi-------------------*/

/*  psi=7000;

  B_and_C_for_GAUSS(koeff,psi,N,A,F3,I,B,C);
  GAUSS(N,B,C);
*/
  dikotomia(&psi,koeff,n,Iexp,dIexp,I,A,F3,B,C);
  ksi2= KSI_2(psi,koeff,n,Iexp,dIexp,I,A,F3,B,C);
  printf(" ksi2= %e\n",ksi2);
 /*------------------ I[i] ------------------------*/
  I[0]=B[0];
  I[1]=B[1]+1./8*B[0]+1./8.*B[2];
  I[2]=B[2]+8./37.*B[1]+9./37.*B[3];

  for(i=3;i<=N-3;i++)
    I[i]=B[i]+1./4.*B[i-1]+1./4.*B[i+1];

  I[N-2]=B[N-2]+9./37.*B[N-3]+8./37.*B[N-1];
  I[N-1]=B[N-1]+1./8.*B[N-2]+1./8.*B[N];
  I[N]=B[N];
 /*------------------------------------------------*/

  progonca(N,I,d);
  b_and_c(N,I,b,c,d);

    /*  curve(S,N,I,b,c,d);*/

/*---------- end -----------------*/
 for(j=0;j<=N;j++)
   free((void*)A[j]);
 free((void*)A);

 for(j=0;j<=N;j++)
   free((void*)F3[j]);
 free((void*)F3);

 free((void*)B);

 for(j=0;j<=N;j++)
  free((void*)C[j]);
 free((void*)C);

 free((void*)b);
 free((void*)c);
 free((void*)d);

}

